package xyz.stachel.zombiesutils.game;

import org.jetbrains.annotations.NotNull;

public class GameMode {
  private final Map map;
  private Difficulty difficulty;

  GameMode(final Map map) {
    this.map = map;
    this.difficulty = Difficulty.NORMAL;
  }

  GameMode(@NotNull final Map map, @NotNull final Difficulty difficulty) {
    this.map = map;
  }

  void changeDifficulty(@NotNull final Difficulty difficulty) {
    this.difficulty = map != Map.ALIEN_ARCADIUM ? difficulty : Difficulty.NORMAL;
  }

  public Map getMap() {
    return this.map;
  }

  public enum Map {
    DEAD_END, BAD_BLOOD, PRISON, ALIEN_ARCADIUM;
  }

  public enum Difficulty {
    NORMAL, HARD, RIP;
  }

  @Override
  public String toString() {
    return map.toString() + "_" + difficulty.toString();
  }
}
